<template>
  <BaseCard
    :title="project.title"
    :main-user="project.author"
    :date="project.creation_datetime"
    :internal-link="links.view"
  >
    <slot slot="pretitle" name="avatarLetter"></slot>
    <template #header>
      <slot name="card-title"></slot>
      <div class="card-options">
        <b-col cols="auto" class="px-0 mr-1">
          <b-button
            data-cy="project-card-output-btn"
            :to="links.outputs"
            :variant="statusVariant"
            size="sm"
          >
            <BrowserIcon class="icon-xxs" />
            Outputs
          </b-button>
        </b-col>
        <b-dropdown
          variant="link"
          toggle-tag="a"
          toggle-class="p-0 card-dropdown dropdown-job-actions"
          no-caret
          right
        >
          <template #button-content>
            <DotsVerticalIcon />
            <slot name="hint"></slot>
          </template>
          <b-dropdown-item link-class="pt-1 pb-1" disabled>
            <UserPlusIcon class="dropdown-item-icon" />
            Invite
          </b-dropdown-item>
          <b-dropdown-item link-class="pt-1 pb-1" disabled>
            <LetterCaseIcon class="dropdown-item-icon" />
            Rename
          </b-dropdown-item>
          <b-dropdown-item link-class="pt-1 pb-1" disabled>
            <CopyIcon class="dropdown-item-icon" />
            Duplicate
          </b-dropdown-item>
          <b-dropdown-item link-class="pt-1 pb-1" disabled>
            <UserMinusIcon class="dropdown-item-icon" />
            Leave
          </b-dropdown-item>
          <DeleteProject :id="project.id">
            <template #deleteAction="{ confirmDelete }">
              <b-dropdown-item
                :link-class="{
                  disabled: project.state && project.state.slug === 'running',
                  'pt-1': true,
                  'pb-1': true,
                }"
                @click="confirmDelete"
              >
                <TrashIcon class="dropdown-item-icon" />
                Remove
              </b-dropdown-item>
            </template>
          </DeleteProject>
        </b-dropdown>
      </div>
    </template>
    <template #body-top>
      <div class="mb-3">
        <b-dropdown
          toggle-class="btn btn-sm text-uppercase dropdown-toggle"
          menu-class="dropdown-menu-center"
          :variant="statusVariant"
        >
          <template #button-content>{{
            project.state ? project.state.title : 'Not ready'
          }}</template>
          <b-dropdown-item :to="openLink" link-class="pt-1 pb-1">
            <ExternalLinkIcon class="dropdown-item-icon" />
            Open
          </b-dropdown-item>
          <b-dropdown-item
            v-if="project.state && project.state.slug === 'running'"
            link-class="pt-1 pb-1"
            disabled
          >
            <PlayerStopIcon class="dropdown-item-icon" />
            Stop
          </b-dropdown-item>
          <b-dropdown-item
            v-if="
              project.state &&
              (project.state.slug === 'ready' ||
                project.state.slug === 'stopped' ||
                project.state.slug === 'pending')
            "
            link-class="pt-1 pb-1"
            disabled
          >
            <PlayerPlayIcon class="dropdown-item-icon" />
            Run
          </b-dropdown-item>
          <b-dropdown-item
            v-if="project.state && project.state.slug === 'finished'"
            link-class="pt-1 pb-1"
            disabled
          >
            <RepeatIcon class="dropdown-item-icon" />
            Restart
          </b-dropdown-item>
        </b-dropdown>
      </div>
    </template>
    <template #body-bottom>
      <div>
        <div class="avatar-list avatar-list-stacked">
          <template v-for="user in displayedUsers">
            <Avatar
              v-if="user.image"
              :key="user.index"
              v-b-tooltip.hover.right="{ variant: 'dark' }"
              :title="user.first_name"
              :img="user.image"
            />
            <Avatar
              v-else
              :key="user.index"
              v-b-tooltip.hover.right="{ variant: 'dark' }"
              :title="user.first_name"
              img="/avatars/user.jpeg"
            >
            </Avatar>
          </template>
        </div>
      </div>
    </template>
    <template #badges>
      <div class="mt-4 lh-sm w-100 cursor-not-allowed">
        <a class="disabled-action">
          <b-badge class="badge-small-text text-uppercase bg-indigo-lt w-100">
            <RouteIcon class="icon-xxs" />
          </b-badge>
        </a>
      </div>
      &nbsp;
      <div class="mt-4 lh-sm w-100 cursor-not-allowed">
        <a class="disabled-action">
          <b-badge class="badge-small-text text-uppercase bg-blue-lt w-100">
            <DatabaseIcon class="icon-xxs" />
          </b-badge>
        </a>
      </div>
    </template>
    <template #progress>
      <b-progress
        class="card-progress"
        :class="
          project.state && project.state.slug === 'running'
            ? 'progress-bar-indeterminate'
            : ''
        "
        :variant="statusVariant"
      >
        <b-progress-bar class="w-100"></b-progress-bar>
      </b-progress>
    </template>
  </BaseCard>
</template>

<script>
const colorMap = {
  'not-ready': 'orange',
  ready: 'orange',
  pending: 'orange',
  running: 'orange',
  stopping: 'orange',
  stopped: 'orange',
  'shutting-down': 'orange',
  finished: 'green',
};

export default {
  props: {
    project: {
      type: Object,
      default() {
        return {
          fullName: '',
          firstName: '',
        };
      },
    },
    date: {
      type: String,
      default: '',
    },
  },
  computed: {
    links() {
      return {
        view: `/projects/${this.project.id}/view`,
        outputs: `/projects/${this.project.id}/view/outputs`,
      };
    },
    displayedUsers() {
      if (!this.project.members || this.project.members.length === 0) {
        if (this.project.author) {
          return [this.project.author];
        }
        return [];
      }
      if (this.project.members.length < 8) {
        return this.project.members;
      }
      return this.project.members.slice(0, 7);
    },
    statusVariant() {
      return this.project.state
        ? colorMap[this.project.state.slug]
        : colorMap['not-ready'];
    },
    openLink() {
      const state = this.project.state;
      if (state && state.slug === 'finished') {
        return this.links.outputs;
      }
      return this.links.view;
    },
  },
};
</script>
